// *******************************************************************
// File    : FormOptions.cs 
// Author  : Igor Tolmachev
// Email   : info@itsamples.com
// Web     : www.itsamples.com 
// You are free to use/modify this code but leave this header intact.
// *******************************************************************

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Microsoft.Win32;

namespace ExifDataChanger
{
	/// <summary>
	/// Summary description for FormOptions.
	/// </summary>
	public class FormOptions : System.Windows.Forms.Form
	{
		private ExifDataChanger.ButtonXP buttonOK;
		private ExifDataChanger.ButtonXP buttonCancel;
		private System.Windows.Forms.Label labelInfo1;
		private System.Windows.Forms.Label labelInfo2;
		private System.Windows.Forms.CheckBox checkBoxDateTime;
		private System.Windows.Forms.CheckBox checkBoxDateTimeOriginal;
		private System.Windows.Forms.CheckBox checkBoxDateTimeDigitized;
		private System.Windows.Forms.GroupBox groupBoxLine;
		private System.Windows.Forms.CheckBox checkBoxBackups;
		private System.Windows.Forms.CheckBox checkBoxFileDate;

		private int m_nLanguage = 0;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public FormOptions(int nLanguage)
		{
			//
			// Required for Windows Form Designer support
			//
			m_nLanguage = nLanguage;

			InitializeComponent();

			buttonOK.DialogResult = DialogResult.OK;
			buttonCancel.DialogResult = DialogResult.Cancel;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.buttonOK = new ExifDataChanger.ButtonXP();
			this.buttonCancel = new ExifDataChanger.ButtonXP();
			this.labelInfo1 = new System.Windows.Forms.Label();
			this.labelInfo2 = new System.Windows.Forms.Label();
			this.checkBoxDateTime = new System.Windows.Forms.CheckBox();
			this.checkBoxDateTimeOriginal = new System.Windows.Forms.CheckBox();
			this.checkBoxDateTimeDigitized = new System.Windows.Forms.CheckBox();
			this.groupBoxLine = new System.Windows.Forms.GroupBox();
			this.checkBoxBackups = new System.Windows.Forms.CheckBox();
			this.checkBoxFileDate = new System.Windows.Forms.CheckBox();
			this.SuspendLayout();
			// 
			// buttonOK
			// 
			this.buttonOK.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(0)), ((System.Byte)(218)), ((System.Byte)(215)), ((System.Byte)(207)));
			this.buttonOK.DefaultScheme = true;
			this.buttonOK.DialogResult = System.Windows.Forms.DialogResult.None;
			this.buttonOK.Hint = "";
			this.buttonOK.Location = new System.Drawing.Point(68, 206);
			this.buttonOK.Name = "buttonOK";
			this.buttonOK.Scheme = ExifDataChanger.ButtonXP.Schemes.Blue;
			this.buttonOK.Size = new System.Drawing.Size(80, 24);
			this.buttonOK.TabIndex = 0;
			this.buttonOK.Text = "OK";
			this.buttonOK.Click += new System.EventHandler(this.OnOK);
			// 
			// buttonCancel
			// 
			this.buttonCancel.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(0)), ((System.Byte)(218)), ((System.Byte)(215)), ((System.Byte)(207)));
			this.buttonCancel.DefaultScheme = true;
			this.buttonCancel.DialogResult = System.Windows.Forms.DialogResult.None;
			this.buttonCancel.Hint = "";
			this.buttonCancel.Location = new System.Drawing.Point(152, 206);
			this.buttonCancel.Name = "buttonCancel";
			this.buttonCancel.Scheme = ExifDataChanger.ButtonXP.Schemes.Blue;
			this.buttonCancel.Size = new System.Drawing.Size(80, 24);
			this.buttonCancel.TabIndex = 1;
			this.buttonCancel.Text = "Cancel";
			// 
			// labelInfo1
			// 
			this.labelInfo1.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.labelInfo1.Location = new System.Drawing.Point(9, 15);
			this.labelInfo1.Name = "labelInfo1";
			this.labelInfo1.Size = new System.Drawing.Size(222, 16);
			this.labelInfo1.TabIndex = 2;
			this.labelInfo1.Text = "Select options below you want to change";
			// 
			// labelInfo2
			// 
			this.labelInfo2.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.labelInfo2.Location = new System.Drawing.Point(9, 33);
			this.labelInfo2.Name = "labelInfo2";
			this.labelInfo2.Size = new System.Drawing.Size(184, 16);
			this.labelInfo2.TabIndex = 3;
			this.labelInfo2.Text = "using this program";
			// 
			// checkBoxDateTime
			// 
			this.checkBoxDateTime.Checked = true;
			this.checkBoxDateTime.CheckState = System.Windows.Forms.CheckState.Checked;
			this.checkBoxDateTime.Location = new System.Drawing.Point(20, 65);
			this.checkBoxDateTime.Name = "checkBoxDateTime";
			this.checkBoxDateTime.Size = new System.Drawing.Size(200, 16);
			this.checkBoxDateTime.TabIndex = 4;
			this.checkBoxDateTime.Text = "Change DateTime value";
			// 
			// checkBoxDateTimeOriginal
			// 
			this.checkBoxDateTimeOriginal.Checked = true;
			this.checkBoxDateTimeOriginal.CheckState = System.Windows.Forms.CheckState.Checked;
			this.checkBoxDateTimeOriginal.Location = new System.Drawing.Point(20, 89);
			this.checkBoxDateTimeOriginal.Name = "checkBoxDateTimeOriginal";
			this.checkBoxDateTimeOriginal.Size = new System.Drawing.Size(200, 16);
			this.checkBoxDateTimeOriginal.TabIndex = 5;
			this.checkBoxDateTimeOriginal.Text = "Change DateTimeOriginal value";
			// 
			// checkBoxDateTimeDigitized
			// 
			this.checkBoxDateTimeDigitized.Checked = true;
			this.checkBoxDateTimeDigitized.CheckState = System.Windows.Forms.CheckState.Checked;
			this.checkBoxDateTimeDigitized.Location = new System.Drawing.Point(20, 113);
			this.checkBoxDateTimeDigitized.Name = "checkBoxDateTimeDigitized";
			this.checkBoxDateTimeDigitized.Size = new System.Drawing.Size(200, 16);
			this.checkBoxDateTimeDigitized.TabIndex = 6;
			this.checkBoxDateTimeDigitized.Text = "Change DateTimeDigitized value";
			// 
			// groupBoxLine
			// 
			this.groupBoxLine.Location = new System.Drawing.Point(8, 195);
			this.groupBoxLine.Name = "groupBoxLine";
			this.groupBoxLine.Size = new System.Drawing.Size(224, 3);
			this.groupBoxLine.TabIndex = 7;
			this.groupBoxLine.TabStop = false;
			// 
			// checkBoxBackups
			// 
			this.checkBoxBackups.Checked = true;
			this.checkBoxBackups.CheckState = System.Windows.Forms.CheckState.Checked;
			this.checkBoxBackups.Location = new System.Drawing.Point(20, 169);
			this.checkBoxBackups.Name = "checkBoxBackups";
			this.checkBoxBackups.Size = new System.Drawing.Size(200, 16);
			this.checkBoxBackups.TabIndex = 8;
			this.checkBoxBackups.Text = "Create Picture Backups";
			// 
			// checkBoxFileDate
			// 
			this.checkBoxFileDate.Checked = true;
			this.checkBoxFileDate.CheckState = System.Windows.Forms.CheckState.Checked;
			this.checkBoxFileDate.Location = new System.Drawing.Point(20, 137);
			this.checkBoxFileDate.Name = "checkBoxFileDate";
			this.checkBoxFileDate.Size = new System.Drawing.Size(200, 16);
			this.checkBoxFileDate.TabIndex = 9;
			this.checkBoxFileDate.Text = "Update File Date value";
			// 
			// FormOptions
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(240, 239);
			this.ControlBox = false;
			this.Controls.Add(this.checkBoxFileDate);
			this.Controls.Add(this.checkBoxBackups);
			this.Controls.Add(this.groupBoxLine);
			this.Controls.Add(this.checkBoxDateTimeDigitized);
			this.Controls.Add(this.checkBoxDateTimeOriginal);
			this.Controls.Add(this.checkBoxDateTime);
			this.Controls.Add(this.labelInfo2);
			this.Controls.Add(this.labelInfo1);
			this.Controls.Add(this.buttonCancel);
			this.Controls.Add(this.buttonOK);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "FormOptions";
			this.Opacity = 0.9;
			this.ShowInTaskbar = false;
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Hide;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = " Options";
			this.TopMost = true;
			this.Load += new System.EventHandler(this.OnLoad);
			this.ResumeLayout(false);

		}
		#endregion

		private void OnLoad(object sender, System.EventArgs e)
		{
			// attempt to read state from registry
			RegistryKey hKey = Registry.CurrentUser.OpenSubKey(@"Software\ExifChanger");
			if(hKey != null)
			{
				int nValue = 0;

				nValue = (int)hKey.GetValue("DTCreated",1);
				if(nValue<1) this.checkBoxDateTime.Checked = false;
				nValue = (int)hKey.GetValue("DTDigitized",1);
				if(nValue<1) this.checkBoxDateTimeDigitized.Checked = false;
				nValue = (int)hKey.GetValue("DTOriginal",1);
				if(nValue<1) this.checkBoxDateTimeOriginal.Checked = false;
				nValue = (int)hKey.GetValue("FileDate",1);
				if(nValue<1) this.checkBoxFileDate.Checked = false;
				nValue = (int)hKey.GetValue("Backups",1);
				if(nValue<1) this.checkBoxBackups.Checked = false;

				hKey.Close();
			}

			if(m_nLanguage != 0)
			{
				this.Text = " ";
				this.labelInfo1.Text = "    ";
				this.labelInfo2.Text = "";
				this.checkBoxDateTime.Text = " DateTime";
				this.checkBoxDateTimeOriginal.Text = " DateTimeOriginal";
				this.checkBoxDateTimeDigitized.Text = " DateTimeDigitized";
				this.checkBoxFileDate.Text = " / ";
				this.checkBoxBackups.Text = "  ";
			}
		}

		private void OnOK(object sender, System.EventArgs e)
		{
			RegistryKey hKey = Registry.CurrentUser.CreateSubKey(@"Software\ExifChanger");
			if(hKey != null)
			{
				int nValue  = 0;
				
				if(this.checkBoxDateTime.Checked) nValue = 1;
				hKey.SetValue("DTCreated", nValue);
				nValue  = 0;
				if(this.checkBoxDateTimeDigitized.Checked) nValue = 1;
				hKey.SetValue("DTDigitized", nValue);
				nValue  = 0;
				if(this.checkBoxDateTimeOriginal.Checked) nValue = 1;
				hKey.SetValue("DTOriginal", nValue);
				nValue  = 0;
				if(this.checkBoxFileDate.Checked) nValue = 1;
				hKey.SetValue("FileDate", nValue);
				nValue  = 0;
				if(this.checkBoxBackups.Checked) nValue = 1;
				hKey.SetValue("Backups", nValue);

				hKey.Close();
			}
		}
	}
}
